﻿#pragma strict
//Heres the shake that one of you guys wanted :P
//First with the variables of course
// v1.0 - Initial Release

//Maximum Distance to shake
var startingShakeDistance : float = 0.8;
//How much it decreases per poll
var decreasePercentage : float = 0.5;
//Speed it travels from poll to poll
var shakeSpeed : float = 50;
//amount of times it polls
var numberOfShakes : int = 10;
//variables to affect the Axis
var affectX : boolean;
var affectY : boolean;
var affectZ : boolean;

function Start () {

}

function Update () {

}
//If anything hits the trigger
function OnTriggerEnter(){
	//Create link to the main camera script.
	var script : MainCameraScript = GameObject.Find("Main Camera").GetComponent(MainCameraScript);

	//to record the time
	var hitTime : float = Time.time;
	//Save the values of the original axis
	var originalPositionX : float = script.xOffset;
	var originalPositionY : float = script.yOffset;
	var originalPositionZ : float = script.zOffset;
	//These both are modified in the while loop
	//Create an original value with the global numberOfShakes
	var shake = numberOfShakes;
	//Create an original value with the global startingShakeDistance
	var shakeDistance : float = startingShakeDistance;
	//while loop when shake is not 0
	while (shake)
	{
		//setup the timer (using the speed)
		var timer : float = (Time.time - hitTime) * shakeSpeed;
		//Affect X values only when true
		if (affectX){
		//update the position of the camera
		script.xOffset = originalPositionX + Mathf.Sin(timer) * shakeDistance;
		}
		//Affect Y values only when true
		if (affectY){
		script.yOffset = originalPositionY + Mathf.Sin(timer) * shakeDistance;
		}
		//Affect Z values only when true
		if (affectZ){
		script.zOffset = originalPositionZ + Mathf.Sin(timer) * shakeDistance;
		}
		//as long as the timer is greater than PI * 2
		if (timer > Mathf.PI * 2){
		//update time
		hitTime = Time.time;
		//decrease the distance by the decreasePercentage ammount. (will increase expodentially if more than 1, DONT DO THAT!)
		shakeDistance *= decreasePercentage;
		//shake - by one. (shortcut)
		shake--;
		}
		//cancel the while loop
		yield;

}
//Reset values after the while loop finishes
script.xOffset = originalPositionX;
script.xOffset = originalPositionY;
script.xOffset = originalPositionZ;
}